
/*
The Camera class is needed by the Renderer to render a Scene. It is one of the arguments in the renderer's .render function.
*/



Irenic.Camera = function(args)
{
    var camera = this;
    
    camera.position = args.position || new Irenic.Vector2D({"x": 0, "y": 0});
    camera.phi = args.phi || 0;
    camera.zoom = 1;
}

Irenic.Camera.prototype.center = function(ob)
{
    var camera = this;

    camera.position.translate(ob.position); //Translate the camera's position to the object's position.

    //Center the camera around the object's image.
    camera.position.x += ob.picture.width/2;
    camera.position.y += ob.picture.height/2;
}

Irenic.Camera.prototype.startFollowing = function(ob)
{
    var camera = this;
        
    camera.center(ob);
    camera.following = ob;    
}

Irenic.Camera.prototype.stopFollowing = function()
{
    var camera = this;

    camera.following = undefined;
}
