//A collection of elements all drawn on top of each other. Any picture class may be an element (Picture, Animation, Composition or State).
Irenic.Composition = function(args)
{
    var composition = this;
    
    composition.elements = args.elements; //Can be a Picture, an Animation, or another Composition, or a State.
    composition.phi = args.phi || 0; //The global phi. All elements are rotated by this.
    composition.alpha = args.alpha || 1; //The global alpha. All elements get this, and thier alpha is modified (multiplied) by this one.
    composition.width = composition.elements[0].width; //Currently, all elements are expected to be the same size. This will change later, a new class is being planned...
    composition.height = composition.elements[0].height;
    composition.r = composition.elements[0].r;
}

//Iterates through the elements of the composition and calls their draw methods (adding the global composition phi and alpha).
Irenic.Composition.prototype.draw = function(args)
{
    var composition = this;

    var phi = args.phi || 0;
    phi += composition.phi;

    var alpha = args.alpha || 1;
    alpha *= composition.alpha;
    
    for (el in composition.elements)
    {
        composition.elements[el].draw({"context": args.context, "position": args.position, "phi": phi, "alpha": alpha});
    }
}

Irenic.Composition.prototype.getRect = function()
{
    var composition = this;

    return composition.elements[0].getRect();
}
