























Irenic.State = function(args)
{
    var state = this;
    
    state.elements = args.elements; //Can be a Picture, an Animation, or a Composition, or another State.
    state.phi = args.phi || 0; //The global phi. All elements are rotated by this.
    state.alpha = args.alpha || 1; //The global alpha. All elements get this, and thier alpha is modified (multiplied) by this one.
    state.i = 0 || args.i; //This denotes the current element.
    state.width = state.elements[state.i].width;
    state.height = state.elements[state.i].height;
    state.r = state.elements[state.i].r;
}

//Draws the current element of the state.
Irenic.State.prototype.draw = function(args)
{
    var state = this;

    var phi = args.phi || 0;
    phi += state.phi;

    var alpha = args.alpha || 1;
    alpha *= state.alpha;
    
    state.getPicture().draw({"context": args.context, "position": args.position, "phi": phi, "alpha": alpha});
}

Irenic.State.prototype.getPicture = function()
{
    var state = this;

    return state.elements[state.i];
}

//Continues on to the next element in the State. Updates width and height accordingly. 
Irenic.State.prototype.next = function()
{
    var state = this;

    ++ state.i;
    state.width = state.elements[state.i].width;
    state.height = state.elements[state.i].height;
}

//Goes back an element in the state. Updates width and height accordingly.
Irenic.State.prototype.prev = function()
{
    var state = this;

    -- state.i;
    state.width = state.elements[state.i].width;
    state.height = state.elements[state.i].height;
}

Irenic.State.prototype.getRect = function()
{
    var state = this;

    return state.getPicture().getRect();
}

