Irenic.defaultSceneSettings =
{
    "sceneAlphaUpdatePS": 30,
    "typeCheck": function(object) //Returns a string which tells the scene where to put the added object.
    {
        if (object instanceof Irenic.Drawable || object instanceof Irenic.Map || object instanceof Irenic.ParticleEmitter || object instanceof Irenic.Rect) //[No user extensions, worry! Add these to an array!!!]
        {
            return "draw"; //Draw objects are essentially either drawables or containers of drawables (like maps).
        }
        
        //Check if light.
        //Check if effect.
        //Check if sound emitter (maybe).        
    }
};

Irenic.defaultRendererSettings =
{
    "fillStyle": "#000"
};

Irenic.defaultEmitterSettings =
{
    "speed": 600, //Particles per second
    "lifeTime": 4000, //In milliseconds.
    "velocity": new Irenic.Range({"from": 100, "to": 250}), //Pixels per second. sqrt(x*x + y*y) == velocity.
    "angularVelocity": new Irenic.Range({"from": 0, "to": Math.PI*10}), //In radians per second.
    "direction": new Irenic.Range({"from": -Math.PI/3, "to": Math.PI/3}), //Full circle. Starting from "up".
    "acceleration": new Irenic.Vector2D({"x": 0, "y": 150}),
    "terminalVelocity": undefined,
    "fade": function(life)
            {
                return 1 - life/this.settings.lifeTime; //If the particle was just created, this will return 1, if the particle's life is spent, it will return 0.
            } 
};
